package shukan;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/** parameters of Shukan */
class ShukanParameters extends JFrame {
    /** panels of the graphic interface */
    private JPanel pPrincipal,p, p1;
    /** buttons of the graphic interface */
    private JButton changerdetheme, theme1, theme2, theme3, retour, changertouches, changercouleurs;
    /** view of the app */
    private ShukanView canvas;
    /** Color background, text, hollydays*/
    private Color BACK_COLOR, BACK_COLOR2, TEXT_COLOR, HOLLY_COLOR, INACTIVE_COLOR; 
    /** Number of modules to display */
    private int nbModules = STD_MODULES_NUMBER;
    /** Standard number of modules */
    private final static int STD_MODULES_NUMBER = 14;   
    /**view of the app */
    private ShukanStudent student;

    /** built a parameter window */
    public ShukanParameters(String titre, ShukanView canvas, ShukanStudent student) {
        super(titre);
        this.canvas = canvas;
        this.student = student;
        p = new JPanel(new GridBagLayout());
        GridBagConstraints gbcprinc = new GridBagConstraints();


        p1 = new JPanel(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();

        changerdetheme = new JButton("Changer de thème");
        changerdetheme.setPreferredSize(new Dimension(190, 25));

        changertouches = new JButton("Changer les touches");
        changertouches.setPreferredSize(new Dimension(190, 25));

        changercouleurs = new JButton("Changer les couleurs");
        changercouleurs.setPreferredSize(new Dimension(190, 25));
        
        changerdetheme.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                remove(pPrincipal);
                validate();
                repaint();

                gbc.insets = new Insets(10, 10, 10, 10);

                theme1 = new JButton("Thème sombre");
                theme1.setPreferredSize(new Dimension(150, 25));
                theme1.addActionListener(new ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        for(int i = 0; i <= 6; i++){
                            BACK_COLOR = new Color(51,51,51);
                            BACK_COLOR2 = new Color(102,102,102);
                            TEXT_COLOR = Color.WHITE;
                            HOLLY_COLOR = new Color(153, 0, 0);
                            INACTIVE_COLOR = new Color (204,204,204);
                            canvas.setBackgroundColor(BACK_COLOR, BACK_COLOR2);
                            canvas.setForeground(TEXT_COLOR, HOLLY_COLOR, INACTIVE_COLOR);
                            student.setBackgroundColor(BACK_COLOR2);
                            student.setForeground(TEXT_COLOR);
                        } 
                        canvas.repaint(); 
                    }
                });

                theme2 = new JButton("Thème clair");
                theme2.setPreferredSize(new Dimension(150, 25));
                theme2.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        for(int i = 0; i <= nbModules; i++){
                            BACK_COLOR = new Color(102,102,102);
                            BACK_COLOR2 = new Color(153,153,153);
                            TEXT_COLOR = Color.BLACK;
                            HOLLY_COLOR = new Color(255,102,102);
                            INACTIVE_COLOR = new Color(51,51,51);
                            canvas.setBackgroundColor(BACK_COLOR, BACK_COLOR2);
                            canvas.setForeground(TEXT_COLOR, HOLLY_COLOR, INACTIVE_COLOR);
                            student.setBackgroundColor(BACK_COLOR2);
                            student.setForeground(TEXT_COLOR);
                        } 
                        canvas.repaint(); 
                    }
                });

                theme3 = new JButton("Thème modéré");
                theme3.setPreferredSize(new Dimension(150, 25));
                theme3.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        for(int i = 0; i <= nbModules; i++){
                            BACK_COLOR = new Color(226,226,226);
                            BACK_COLOR2 = Color.LIGHT_GRAY;
                            TEXT_COLOR = Color.BLACK;
                            HOLLY_COLOR = new Color (1.f, 0.8f, 0.7f);
                            INACTIVE_COLOR = new Color (0.5f, 0.5f, 0.5f);
                            canvas.setBackgroundColor(BACK_COLOR, BACK_COLOR2);
                            canvas.setForeground(TEXT_COLOR, HOLLY_COLOR, INACTIVE_COLOR);
                            student.setBackgroundColor(BACK_COLOR2);
                            student.setForeground(TEXT_COLOR);

                        } 
                        canvas.repaint(); 
                    }
                });

                retour = new JButton("Retour");
                retour.setPreferredSize(new Dimension(150, 25));
                retour.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        remove(pPrincipal);
                        validate();
                        repaint();

                        p.removeAll();
                        gbcprinc.insets = new Insets(10, 10, 10, 10);
 
                        gbcprinc.gridx = 0;
                        gbcprinc.gridy = 0;
                        gbc.fill = GridBagConstraints.HORIZONTAL;
                        p.add(changerdetheme, gbcprinc);
                
                        gbcprinc.gridx = 0;
                        gbcprinc.gridy = 1;
                        p.add(changertouches, gbcprinc);
                        
                        gbcprinc.gridx = 0;
                        gbcprinc.gridy = 2;
                        p.add(changercouleurs, gbcprinc);

                        pPrincipal = p;

                        add(pPrincipal);
                        validate();
                        repaint();
                    }
                });

                gbc.gridx = 0;
                gbc.gridy = 0;
                gbc.fill = GridBagConstraints.HORIZONTAL;
                p1.add(theme1, gbc);
                
                gbc.gridx = 0;
                gbc.gridy = 1;
                p1.add(theme2, gbc);
                
                gbc.gridx = 0;
                gbc.gridy = 2;
                p1.add(theme3, gbc);
                
                gbc.gridx = 0;
                gbc.gridy = 3;
                p1.add(retour, gbc);

                add(p1);
                pPrincipal = p1;
                validate();
                repaint();
            }
        });

        gbcprinc.insets = new Insets(10, 10, 10, 10);
 
        gbcprinc.gridx = 0;
        gbcprinc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        p.add(changerdetheme, gbcprinc);

        gbcprinc.gridx = 0;
        gbcprinc.gridy = 1;
        p.add(changertouches, gbcprinc);
        
        gbcprinc.gridx = 0;
        gbcprinc.gridy = 2;
        p.add(changercouleurs, gbcprinc);

        pPrincipal = p;
        add(pPrincipal);
    }
}
